%%
%% $Id: appthreadchange.tex,v 1.7 2003-03-07 19:37:22 baurma Exp $
%%

\section{JNukeThreadChange}

\label{app:threadchange}

The \texttt{JNukeThreadChange} is the internal representation of the
necessary conditions for a thread change within a replay schedule. A
vector of \texttt{JNukeThreadChange} objects can be obtained by using
the \\
\texttt{JNukeScheduleFileParser} object.

%% ------------------------------------------------------------------

\subsection{Constructor}

\code{
JNukeObj * \\
JNukeThreadChange\_new (\\
\tab	JNukeObj * mem \\
)
}

\subsubsection{Description}

The constructor is called to obtain a new instance of a 
\texttt{JNukeThreadChange} object. The memory required is
drawn from a memory manager.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	Reference to a memory manager object.
\end{description}

\subsubsection{Return value}

This function returns a new instance of a \texttt{JNukeThreadChange} 
object.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_set}

\code{
void \\
JNukeThreadChange\_set ( \\
\tab	JNukeObj * this, \\
\tab	const unsigned int thread, \\
\tab	const unsigned int method, \\
\tab	const unsigned int ofs, \\
\tab	const unsigned int iter \\
)
}

\subsubsection{Description}

Set integer properties of a thread change object.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the thread change object.
\ttitem{thread}
	New value for the thread identifier.
\ttitem{method}
	New value for the method index.
\ttitem{ofs}
	New value for the bytecode offset.
\ttitem{iter}
	New value for the iteration index.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_setClassName}

\code{
void \\
JNukeThreadChange\_setClassName (\\
\tab	JNukeObj * this, \\
\tab	const char *className \\
)
}

\subsubsection{Description}

Set class name property of a thread change object.
To query this property, the functions \\
\texttt{JNukeThreadChange\_getClassName} and \\
\texttt{JNukeThreadChange\_getClassNameAsObject} may
be used.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{className}
	New value for the class name property.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getClassName}

\code{
const char * \\
JNukeThreadChange\_getClassName ( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get class name property value of a thread change object.
The value is returned as a \mbox{\texttt{char*}}. The 
method \\
\texttt{JNukeThreadChange\_getClassNameAsObject} may
be used to obtain the current value as a \mbox{\texttt{JNukeObj*}}.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the thread change object.
\end{description}

\subsubsection{Return value}

This function returns the current setting for the class
name property.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getClassNameAsObject}

\code{
JNukeObj * \\
JNukeThreadChange\_getClassNameAsObject ( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get class name property value of a thread change object.
The value is returned as a \mbox{\texttt{JNukeObj*}}. The 
function \texttt{JNukeThreadChange\_getClassName} may
be used to obtain the current value as a \mbox{\texttt{char*}}.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\end{description}

\subsubsection{Return value}


%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_setCommand}

\code{
void \\
JNukeThreadChange\_setCommand ( \\
\tab	JNukeObj * this, \\
\tab	const int command \\
)
}

\subsubsection{Description}

Set the command property of a thread change. The function 
\texttt{JNukeThreadChange\_getCommand} may be used to
query this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{command}
	New value for the command property.
	Currently only the symbolic value \texttt{cmd\_switch}
	is allowed.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getCommand}

\code{
int \\
JNukeThreadChange\_getCommand (\\
\tab	const JNukeObj * this \\
)
}


\subsubsection{Description}

Get current command property value of a thread change
object. The function \texttt{JNukeThreadChange\_setCommand} may be used to 
set this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\end{description}

\subsubsection{Return value}

The current value for the command property.


%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_setThreadIndex}

\code{
void \\
JNukeThreadChange\_setThreadIndex (\\
\tab	JNukeObj * this, \\
\tab	const int idx \\
)
}

\subsubsection{Description}

Set the thread index property of a thread change object.
The function \texttt{JNukeThreadChange\_getThreadIndex} may be used to 
query this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{idx}
	New value for the thread index property. 
	Negative values are not allowed.
\end{description}


\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getThreadIndex}

\code{
int \\
JNukeThreadChange\_getThreadIndex (\\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get current value of the thread index property of a 
thread change object. The function \\
\texttt{JNukeThreadChange\_setThreadIndex} may be
used to query this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\end{description}

\subsubsection{Return value}

This function returns the current setting for the
thread index property of a thread change object.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_setMethodIndex}

\code{
void \\
JNukeThreadChange\_setMethodIndex (\\
\tab	JNukeObj * this, \\
\tab	const int idx \\
)
}

\subsubsection{Description}

Set method index property of a thread change object.
The function \texttt{JNukeThreadChange\_getMethodIndex} may be used 
to query this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{idx}
	New value for the method index object. The
	value may not be negative.
\end{description}

\subsubsection{Return value}

None.


%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getMethodIndex}

\code{
int \\
JNukeThreadChange\_getMethodIndex ( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get current method index value of a thread change
object. The function \texttt{JNukeThreadChange\_setMethodIndex} 
may be used to set this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\end{description}

\subsubsection{Return value}

This function returns the current value for the
method index property.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_setByteCodeOffset}

\code{
void \\
JNukeThreadChange\_setByteCodeOffset ( \\
\tab	JNukeObj * this, \\
\tab	const int newofs \\
)
}

\subsubsection{Description}

Set bytecode offset of a thread change object. The function
\texttt{JNukeThreadChange\_getByteCodeOffset} may be used
to query this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{newofs}
	New value for the bytecode offset property.
	The number may not be negative.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getByteCodeOffset}

\code{
int \\
JNukeThreadChange\_getByteCodeOffset (\\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get current value of the bytecode offset property of
a thread change object. The function \\
\texttt{JNukeThreadChange\_setByteCodeOffset} may be
used to set this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\end{description}

\subsubsection{Return value}

This function returns the current setting for the
bytecode offset property.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_setIterationIndex}

\code{
void \\
JNukeThreadChange\_setIterationIndex ( \\
\tab	JNukeObj * this, \\
\tab	const int index \\
)
}

\subsubsection{Description}

Set iteration index of a thread change object. The function \\
\texttt{JNukeThreadChange\_getIterationIndex} may be used
to query this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{index}
	New value for the iteration index property.
	The value must be greater than zero.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_getIterationIndex}

\code{
int \\
JNukeThreadChange\_getIterationIndex ( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get iteration index property of a thread change object.
The function \\
\texttt{JNukeThreadChange\_setIterationIndex} may be used 
to set this property.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\end{description}

\subsubsection{Return value}

This function returns the current setting for the
iteration index property.

%% ------------------------------------------------------------------

\subsection{JNukeThreadChange\_parse}

\code{
int \\
JNukeThreadChange\_parse ( \\
\tab	JNukeObj * this, \\
\tab	const char *line \\
)
}

\subsubsection{Description}

Parse a single line of a thread replay schedule file into a
thread change object. The contents of the line must follow
the specification given in Appendix~\ref{jreplay:cxfileformat}.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a thread change object.
\ttitem{line}
	Line to be parsed.
\end{description}

\subsubsection{Return value}

%% ------------------------------------------------------------------
